const { simpleDate } = require('../Util');

class Calendar {
  static dates = [];
  static daysNumber = [];

  get dates() {
    return Calendar.dates;
  }

  clear() {
    Calendar.dates = [];
  }

  addDay(date, dayNumber) {
    Calendar.dates.push(simpleDate(date));
    Calendar.daysNumber.push(dayNumber);
  }

  addDateInResult(origin, index, result) {
    if (origin[index]) {
      result.push(origin[index]);
    }
  }

  handleYesterdayAndTomorrow(allDates, currentDayInfo) {
    const result = [];
    const todayIdx = allDates.find((date) => date === currentDayInfo);
    this.addDateInResult(allDates, todayIdx - 1, result);
    this.addDateInResult(allDates, todayIdx + 1, result);
    return result;
  }

  getYesterdayAndTomorrowDays(currentDay) {
    return this.handleYesterdayAndTomorrow(Calendar.daysNumber, currentDay);
  }

  getYesterdayAndTomorrowDates(currentDay) {
    return this.handleYesterdayAndTomorrow(Calendar.dates, currentDay);
  }
}

module.exports = new Calendar();
