class Cost {
  static dayPu = 0;
  static totalCost = 0;
  static costAvg = 0;
  static totalConsumers = 0;

  get dayPu() {
    return Cost.dayPu;
  }

  get totalCost() {
    return Cost.totalCost;
  }

  get costAvg() {
    return Cost.costAvg;
  }

  get totalConsumers() {
    return Cost.totalConsumers;
  }

  getTotalPu() {
    return Cost.totalConsumers ? Cost.totalCost / Cost.totalConsumers : 0;
  }

  nextDay() {
    Cost.dayPu = 0;
    Cost.costAvg = 0;
  }

  calculate(dish, { comensais, comenDIV }) {
    const { VLR_CUSTO_PRATO, percentualConsumo } = dish;
    const percConsumption = Number(percentualConsumo) / 100;
    const dishCost = Number(VLR_CUSTO_PRATO || 0) * percConsumption;
    Cost.dayPu += (dishCost * Number(comensais)) / parseInt(comenDIV, 10);
    Cost.costAvg += dishCost;
  }

  getDishCost(dish) {
    return (Number(dish.percentualConsumo) / 100) * Number(dish.VLR_CUSTO_PRATO);
  }

  totalizeDay(consumers) {
    Cost.totalCost += Cost.dayPu * consumers;
    Cost.totalConsumers += consumers;
  }
}

module.exports = new Cost();
